clear all
close all
%%
wM = [0.257 0.272]*1e-3/2; % waist raduis at MM
zM = [-1.202 -1.212]; % waist position from MM, negative means upstream
dimensions = {'X', 'Y'};
colors={'r', 'b'};

fL=[-1145.6e-3, -1145.6e-3];
%%
for ii=1:length(dimensions)
    MM=beamPath();
    MM.addComponent(component.flatMirror(0, 'ModeMaster'));
    qMM = beamq.beamWaistAndZ(wM(ii), zM(ii));
    MM.seedq = qMM;
    MM.seedz = 0;

    % PLCC-25.4-515.1-UV-1064
%    fL = -1145.6e-3;
    zL = 90e-3;
    MM.addComponent(component.lens(fL(ii), zL, 'Lens f=-1145.6mm'));

    % Launcher
    d0 = (205+114+266)*1e-3;
    z0 = zL + d0;
    MM.addComponent(component.flatMirror(z0, 'Launcher'));

    % what is the source q?
    qSrc=MM.qPropagate(z0);
    MM.targetq = qSrc;
    MM.targetz = z0;
    z=-0.1:0.01:z0+0.1;
    hold on;
    MM.plotBeamWidth(z, colors{ii});

    % just for plotting
    ysign = (ii-1.5)*2;
    yfull=MM.seedq.beamWidth;
    text(0, ysign*yfull*0.7, ['src ' dimensions{ii} ' waist radius=' num2str(MM.seedq.waistSize*1000) 'mm'], 'color', colors{ii});
    text(0, ysign*yfull*0.6, ['src waistZ =' num2str(MM.seedq.waistZ) 'm'], 'color', colors{ii});
    xoff = 0.3*z(1)+0.7*z(end);
    text(xoff, ysign*yfull*0.7, ['target ' dimensions{ii} 'waist radius=' num2str(MM.targetq.waistSize*1000) 'mm'], 'color', colors{ii});
    text(xoff, ysign*yfull*0.6, ['target waistZ =' num2str(MM.targetq.waistZ) 'm'], 'color', colors{ii});

end
%%
MM.plotComponents(z);